/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	mcu_adc.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2018-02-27
	*
	*	汾 		V1.0
	*
	*	˵ 		ƬADC
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭ
#include "mcu_rcc.h"
#include "mcu_adc.h"


void MCU_ADCx_Init(ADC_TypeDef *ADC_Group, unsigned int ADC_Clock, unsigned int ADC_Mode, FunctionalState ADC_ContinuousConvMode,
						unsigned int ADC_ExternalTrigConv, unsigned int ADC_DataAlign,unsigned char ADC_NbrOfChannel,
						const unsigned char *adc_channel_list, _Bool temp_flag)
{
	
	unsigned char i = 0;

	ADC_InitTypeDef adc_initstruct;
	
	MCU_RCC(ADC_Group, ENABLE);
	
	RCC_ADCCLKConfig(RCC_PCLK2_Div6);								//ADCƵx 72M/x=y,ADCʱ䲻ܳ14M
	
	ADC_DeInit(ADC_Group);											//λADCx, ADCx ȫĴΪȱʡֵ
	
	if(ADC_NbrOfChannel > 1)
	{
		adc_initstruct.ADC_NbrOfChannel = ADC_NbrOfChannel;			//˳йתADCͨĿ
		adc_initstruct.ADC_ScanConvMode = ENABLE;					//ģתڶͨģʽ
	}
	else if(ADC_NbrOfChannel == 1)
	{
		adc_initstruct.ADC_NbrOfChannel = 1;						//˳йתADCͨĿ
		adc_initstruct.ADC_ScanConvMode = DISABLE;					//ģתڵͨģʽ
	}

	adc_initstruct.ADC_ContinuousConvMode = ADC_ContinuousConvMode;	//ģתתģʽ
	adc_initstruct.ADC_DataAlign = ADC_DataAlign;					//ADCҶ
	adc_initstruct.ADC_ExternalTrigConv = ADC_ExternalTrigConv;		//תⲿ
	adc_initstruct.ADC_Mode = ADC_Mode;								//ADCģʽ:ڶģʽ
	
	ADC_Init(ADC_Group, &adc_initstruct);							//ʼADC
	
	for(; i < ADC_NbrOfChannel; i++)								//ADCͨɼ˳,
		ADC_RegularChannelConfig(ADC_Group, adc_channel_list[i], i + 1, ADC_SampleTime_41Cycles5);
	
																	//ʱ㷽ʽ
																	//TCONV =  + 12.5
																	//ADCʱӣ籾12MHz
																	//TCONV = 41.5 + 12.5 = 54
																	//54 x 1/12 = 4.5us
																	//
																	//12MHz£תһεʱ䣺
																	//ADC_SampleTime_1Cycles51.17us
																	//ADC_SampleTime_7Cycles51.67us
																	//ADC_SampleTime_13Cycles52.17us
																	//ADC_SampleTime_28Cycles53.42us
																	//ADC_SampleTime_41Cycles54.5us
																	//ADC_SampleTime_55Cycles55.67us
																	//ADC_SampleTime_71Cycles57.0us
																	//ADC_SampleTime_239Cycles521.0us
	
	if(ADC_Group == ADC1 && temp_flag)
		ADC_TempSensorVrefintCmd(ENABLE);							//ڲ¶ȴ//ADC1ͨ16
	
	ADC_Cmd(ADC_Group, ENABLE);										//ʹָADC
	
	ADC_ResetCalibration(ADC_Group);								//ʹܸλУ׼  
	 
	while(ADC_GetResetCalibrationStatus(ADC_Group));				//ȴλУ׼
	
	ADC_StartCalibration(ADC_Group);								//ADУ׼
 
	while(ADC_GetCalibrationStatus(ADC_Group));						//ȴУ׼

}
