/**
	************************************************************
	************************************************************
	************************************************************
	*	ļ 	mcu_dma.c
	*
	*	ߣ 		ż
	*
	*	ڣ 		2018-02-25
	*
	*	汾 		V1.0
	*
	*	˵ 		ƬDMA
	*
	*	޸ļ¼	
	************************************************************
	************************************************************
	************************************************************
**/

//Ƭ
#include "mcu_rcc.h"
#include "mcu_dma.h"


/*
************************************************************
*	ƣ	MCU_DMA_Init
*
*	ܣ	ƬDMAʼ
*
*	ڲ	dma_groupDMA
*				dma_channelDMAͨ
*				dma_pbaַ
*				dma_mbaڴַ
*				dma_dir䷽
*				dma_buffersizeС
*				dma_piַĴǷ
*				dma_miڴַĴǷ
*				dma_pdsݿ
*				dma_mdsڴݿ
*				dma_modeģʽ
*				dma_priorityDMAͨȼ
*				dma_m2mDMAͨǷڴ浽ڴ洫
*
*	ز	
*
*	˵		
************************************************************
*/
void MCU_DMA_Init(DMA_TypeDef *dma_group, DMA_Channel_TypeDef *dma_channel, unsigned int dma_pba, unsigned int dma_mba, unsigned int dma_dir,
					unsigned int dma_buffersize,unsigned int dma_pi, unsigned int dma_mi, unsigned int dma_pds, unsigned int dma_mds,
					unsigned int dma_mode, unsigned int dma_priority, unsigned int dma_m2m)
{

	DMA_InitTypeDef dma_initstruct;
	
	MCU_RCC(dma_group, ENABLE);								//ʹʱ
	
	DMA_DeInit(dma_channel);								//DMAͨ1ĴΪȱʡֵ
	
	dma_initstruct.DMA_PeripheralBaseAddr = dma_pba;		//DMAַ
	dma_initstruct.DMA_MemoryBaseAddr = dma_mba;			//DMAڴַ
	dma_initstruct.DMA_DIR = dma_dir;						//ݴ䷽
	dma_initstruct.DMA_BufferSize = dma_buffersize;			//DMAͨDMAĴС
	dma_initstruct.DMA_PeripheralInc = dma_pi;				//ַĴǷ
	dma_initstruct.DMA_MemoryInc = dma_mi;					//ڴַĴǷ
	dma_initstruct.DMA_PeripheralDataSize = dma_pds;		//ݿ
	dma_initstruct.DMA_MemoryDataSize = dma_mds;			//ڴݿ
	dma_initstruct.DMA_Mode = dma_mode;						//ģʽ
	dma_initstruct.DMA_Priority = dma_priority;				//DMAͨȼ
	dma_initstruct.DMA_M2M = dma_m2m;						//DMAͨǷڴ浽ڴ洫
	
	DMA_Init(dma_channel, &dma_initstruct);					//ʼ

}

/*
************************************************************
*	ƣ	MCU_DMA_ResetMemoryBaseAddr
*
*	ܣ	ƬDMAڴַ
*
*	ڲ	dma_channelDMAͨ
*				mAddrڴַ
*				numС
*
*	ز	
*
*	˵		
************************************************************
*/
void MCU_DMA_ResetMemoryBaseAddr(DMA_Channel_TypeDef *dma_channel, unsigned int mAddr, unsigned short num)
{

	dma_channel->CCR &= (unsigned short)(~DMA_CCR1_EN);	//رDMA1ָʾͨ
			
	dma_channel->CMAR = mAddr;							//DMAͨڴַ
	dma_channel->CNDTR = num;							//DMAͨDMAĴС
	
	dma_channel->CCR |= DMA_CCR1_EN;

}
